<?php
# ----------------------------------------------------------------------
# settings:
#-----------------------------------------------------------------------
# check if we display test file
$ws_snow_test   = false;
$ws_snow_test   = true;         // comment when ready with testing.
# ----------------------------------------------------------------------
# end of settings:
#-----------------------------------------------------------------------
if (isset($_REQUEST['sce']) && strtolower($_REQUEST['sce']) == 'view' ) {
   $filenameReal = __FILE__;			# display source of script if requested so
   $download_size = filesize($filenameReal);
   header('Pragma: public');
   header('Cache-Control: private');
   header('Cache-Control: no-cache, must-revalidate');
   header("Content-type: text/plain");
   header("Accept-Ranges: bytes");
   header("Content-Length: $download_size");
   header('Connection: close');
   readfile($filenameReal);
   exit;
}
$pageName	= 'ws_snow.php';        
$pageVersion	= '0.00 2016-01-20';    
#-----------------------------------------------------------------------
# 0.00 2016-01-20	first version		
# ----------------------------------------------------------------------
if (!isset($SITE)){echo "<h3>invalid call to script $pageName</h3>";exit;}
$SITE['wsModules'][$pageName] = 'version: ' . $pageVersion;
$pageFile = basename(__FILE__);			// check to see this is the real script
if ($pageFile <> $pageName) {$SITE['wsModules'][$pageFile]	= 'this file loaded instead of '.$pageName;}
ws_message ('<!-- module '.$pageFile.' ==== '.$SITE['wsModules'][$pageFile].' -->');
# ----------------------------------------------------------------------
$ws_snow_script = $pageFile;
#-----------------------------------------------------------------------
# Init language files
$ws_dir 	= dirname(__FILE__).'/';
$dir_lang 	= $ws_dir.'lang/';	// lang files for this script are here
$pathString     = '<!-- adding '.$pageFile.' langauge entries fropm '.$dir_lang.' -->'.PHP_EOL;
langMergeFile ($dir_lang);
echo $pathString;
#
$page_title     = langtransstr('Snow measurements');
$ws_snow_file   = 'ws_snow.txt';
#
#$uomBackup['uomSnow']
?>
<!-- ws_snow.php loaded -->
<div class = "blockDiv">
<style scoped>
        .ws_snow        { width: 400px; margin: 0 auto;}
        .ws_snow label  { width: 300px; float: right;  text-align: left;  padding-top: 5px; }
        .ws_snow input  { width: 80px;  padding: 3px; margin: 3px;  /* border: 1px solid #bac5d6;font: 10px Verdana, sans-serif;background: #fff; */ text-align: right;  }
        .td_r           {text-align: right;}
</style>


<?php   # <h3 class = "blockHead">'.$page_title.'</h3>
# lets load / clean the current snow file
if ($ws_snow_test) {$ws_snow_file = $ws_dir.$ws_snow_file; } else {$ws_snow_file = $SITE['cacheDir'].$ws_snow_file;}

$ws_snow_arr    = ws_snow_load_txt($ws_snow_file);      # echo '<pre>'.print_r($ws_snow_arr,true); exit;
if (!is_array($ws_snow_arr) ){$snow_file_found = false;} else {$snow_file_found = true;}
#
if (isset ($_POST['snow_sent']) ) {
        ws_snow_add();
        $ws_snow_arr = '';
        $ws_snow_arr = ws_snow_load_txt($ws_snow_file);
}
elseif (isset ($_POST['snow_clear']) ) {
        unset ($_POST);
        unset ($_REQUEST['snow']);
}
#echo '<pre>'.print_r($_POST,true).'</pre>'.PHP_EOL; 

# check if &snow is on the url
$snow_update    = ws_url_contains('snow','');
#
if (!$snow_file_found && !$snow_update) {       // no file +  no update => end script
        echo '<h3 style= text-align: center;>'.langtransstr('No snow file found and no input mode for snow-data selected').'</h3>'.PHP_EOL;
        echo '</div>'.PHP_EOL;
        return false;
}
# scheck if password is set and valid
$pw_result      = ws_url_pw_check();
if ($pw_result <> 'OK') {
        echo ws_message ('<!-- '.$pageFile.' pw = '.$pw_result.' -->',true);
        $pw_result = false;
}
else {  $pw_result = true;
}
#
$string = $string2  = '';
$display = 'display: block;';
#
if ($snow_update && $pw_result) {
# all set for accepting a line of snow measurement.
# check for last measurement if it is there.
        if ($snow_file_found) {
                foreach ($ws_snow_arr as $key => $arr) {
                        $last_height    = $arr['height']; 
                        $last_date      = $arr['ymd']; 
                        break;
                }      
        }
# display two lines 1 with last 1 with empty fields
        $string .= '<h3 class = "blockHead">'.$page_title.'</h3>
        <table class="genericTable" >
<tr><td>'.PHP_EOL;
        $string .=  '<h3 class = "blockHead">'.langtransstr('Snow measurement input').'</h3>'.PHP_EOL;
        if (isset ($last_height) ) {
                $string .= '<p><br />'.langtransstr('Last height').': '.$last_height.$uomBackup["uomSnow"].' '.langtransstr(' - measured on').' '.date ($SITE["dateOnlyFormat"], strtotime($last_date.'T120000') ).'</p>'.PHP_EOL;
        }
        $explain= '';

        $string .= '
<div class="ws_snow">
    <form method="post" id="snow_form" action="'.$SITE['pages']['ws_snow'].'&pw='.$SITE['password'].'&snow&amp;lang='.$lang.$extraP.$skiptopText.'">
        <input type="text"  id="snow_year" name="snow_year"      maxlength="4" value="'.date ('Y').'" />
        <label>'.langtransstr('Year').'</label><br />

        <input type="text" id="snow_month" name="snow_month"    maxlength="2" value="'.date ('m').'" />
        <label>'.langtransstr('Month').'</label><br />

        <input type="text" id="snow_day" name="snow_day"        maxlength="2" value="'.date ('d').'" />
        <label>'.langtransstr('Day').'</label><br />

        <input type="text" id="snow_height" name="snow_height"  maxlength="6" value="0" />
        <label>'.langtransstr('Current snow height').'</label><br />

        <input type="text" id="snow_fall" name="snow_fall"      maxlength="6" value="0" />
        <label>'.langtransstr('Snowfall since last measuremnet').'</label><br />
        <br />
        <input type="submit" id="snow_sent"     name="snow_sent"        value="'.langtransstr('submit').'" />
        <input type="submit" id="snow_clear"    name="snow_clear"       value="'.langtransstr('clear and end').'" />
    </form>
<br />
</div>
</td><td style="vertical-align: top;">'.PHP_EOL;

        $string .= '<h3 class = "blockHead">'.langtransstr('Current snow details').'</h3><br />'.PHP_EOL;
#
} // eo $snow_update && $pw_result
else {  $string.= '<h3 class = "blockHead">'.$page_title.' ('.$uomBackup["uomSnow"].')&nbsp;&nbsp;
<a href="javascript:snow_show()">
<img src="'.$SITE['imgDir'].'i_symbolWhite.png" alt=" " style="margin-top: 2px; width: 12px;"></a>
</h3>
<script type="text/javascript">
  function snow_show(){
    if (!document.getElementById)
    return
    which1 = document.getElementById("snow_small")
    which2 = document.getElementById("snow_large")
    if (which1.style.display=="block") {
        which1.style.display="none"
        which2.style.display="block"
    }
    else {
        which2.style.display="none"
        which1.style.display="block"
    }
  }
</script>'.PHP_EOL;
        $flip_flop=true;
        $string .= '<div id="snow_small" style="width: 400px; margin: 0 auto; '.$display.'">';
        $string .= '<table class="genericTable">'.PHP_EOL;
        $string .= '<tr><th>'.langtransstr('Date').'</th><th class="td_r">'.langtransstr('Current height').'</th><th class="td_r">'.langtransstr('Fresh').'</th><th class="td_r">'.langtransstr('Melt').'</th></tr>'.PHP_EOL;
        $display = 'display: none;';
}
#
#       display current data 
$string2 .= '<div id="snow_large" style="width: 400px; margin: 0 auto; '.$display.'">';
$string2 .= '<table class="genericTable">'.PHP_EOL;
$string2 .= '<tr><th>'.langtransstr('Date').'</th><th class="td_r">'.langtransstr('Current height').'</th><th class="td_r">'.langtransstr('Fresh').'</th><th class="td_r">'.langtransstr('Melt').'</th></tr>'.PHP_EOL;
$end    = count($ws_snow_arr);
if (!isset ($uomBackup["uomSnow"]) )    {$uomBackup["uomSnow"] = $SITE["uomRain"];}
if (!isset ($SITE["decSnow"]) )         {$decSnow = 2;} else {$decSnow = $SITE["decSnow"];}
$count  = 0;
if (is_array($ws_snow_arr) ) {
    foreach ($ws_snow_arr as $key => $arr) {
        $date   = date ($SITE["dateOnlyFormat"], strtotime($arr['ymd'].'T120000') );
        $height = wsNumber ($arr['height'],     $decSnow).'&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
        $new    = wsNumber ($arr['new_snow'],   $decSnow).'&nbsp;&nbsp;';
        $melt   = wsNumber ($arr['last_melt'],  $decSnow).'&nbsp;&nbsp;';
        
        #$SITE["uomSnow"]  $SITE["decSnow"]   wsNumber ($num, $dec=$SITE["decSnow"]);
        $line  = '<tr><td>'.$date.'</td><td class="td_r">'.$height.'</td><td class="td_r">'.$new.'</td><td class="td_r">'.$melt.'</td></tr>'.PHP_EOL;
        if ($count == 0 && isset ($flip_flop)) {
                $string .= $line;
                $string .= '</table>'.PHP_EOL;
                $string .= '</div>'.PHP_EOL;
                $count++;
        }
        $string2 .= $line; 
    } // eo for $ws_snow_arr
}
$string2 .= '</table>'.PHP_EOL;
$string2 .= '<p style="text-align: center; margin: 0 auto;"><small>'.langtransstr('Manual measurements - unit used').': '.$uomBackup["uomSnow"].'</small></p>'.PHP_EOL;
$string2 .= '</div>'.PHP_EOL;
#
$string .= $string2;

if ($snow_update && $pw_result) {
        $string .= '</td></tr></table>'.PHP_EOL;
}
echo $string.'</div>'.PHP_EOL;
return true;

function ws_snow_add() {
        global $SITE;
        global $this_year,  $last_year;
        global $snow_first, $snow_last;
        global $arr_snow_months;
        global $ws_snow_file;
        $my     = basename(__FILE__).' -> '.__FUNCTION__;
        ws_message ('<!-- '.$my.' ('.__LINE__.'): this function loaded -->');
        $snow_year      = trim($_POST['snow_year']);
        $snow_month     = trim($_POST['snow_month']);
        $snow_day       = trim($_POST['snow_day']);
        $snow_height    = trim($_POST['snow_height']);
        $snow_fall      = trim($_POST['snow_fall']);
        $string ='|'.$snow_year.'|'.$snow_month.'|'.$snow_day.'|deft|'.$snow_height.'|'.$snow_fall.'|'."\n";
 #       echo $string;
        $result = file_put_contents($ws_snow_file,$string,FILE_APPEND);
        ws_message ('<!-- '.$my.' ('.__LINE__.'): adding '.$string.' to the file: '.$ws_snow_file.' - result is '.$result.' -->');
}
function ws_url_contains($search,$value = '') {
#        global $ws_snow_script;
        $my     = basename(__FILE__).' -> '.__FUNCTION__;
        ws_message ('<!-- '.$my.' ('.__LINE__.'): this function loaded -->');  
              
        if (!isset ($_REQUEST[$search]) ) {
                ws_message ('<!-- '.$my.' ('.__LINE__.'): no '.$search.' parameter in url -->'); 
                return false;
        }
        if ($value == '') {
                ws_message ('<!-- '.$my.' ('.__LINE__.'): '.$search.' in url, no value checking requested -->'); 
                return true;
        }
        if ($value == trim($_REQUEST[$search]) ){
                ws_message ('<!-- '.$my.' ('.__LINE__.'): '.$search.' in url but invalid value found -->'); 
                return true;
        }
        ws_message ('<!-- '.$my.' ('.__LINE__.'): '.$search.' in url and correct value found -->'); 
        return false;
}
function ws_url_pw_check() {
        global $SITE;
        $my     = basename(__FILE__).' -> '.__FUNCTION__;
        ws_message ('<!-- '.$my.' ('.__LINE__.'): this function loaded -->');
        if (!isset ($SITE['password']) || $SITE['password'] == '') {
                return 'Password should be set  in wsUserSettings and used for using this facility';
        }
        if (!isset ($_REQUEST['pw']) )                  {return 'no password in url';}
        if ($_REQUEST['pw'] <> $SITE['password'] )      {return 'invalid password';} 
        return 'OK';     
}
function ws_snow_globals () {
        global $SITE;
        global $this_year,  $last_year;
        global $snow_first, $snow_last;
        global $arr_snow_months;
        
        $my     = basename(__FILE__).' -> '.__FUNCTION__;
        ws_message ('<!--'.$my.' ('.__LINE__.'): this function loaded -->');
        
        $this_year      = date ('Y');
        $month          = date ('n');
        $last_year      = $this_year;
        $snow_first     = '04';         // SH
        $snow_last      = '09';         // SH
#                                  J F M A M J J A S O N D      
        $arr_snow_months= array (0,0,0,0,4,5,6,7,8,9,0,0,0);
        $arr_snow_nh    = array (0,7,8,9,0,0,0,0,0,0,4,5,6);        
        if ($SITE['longitude'] > 0) { $snow_nh = true; } else { $snow_nh = false; }
        if ($snow_nh && $month < 5) {   // winter NH in two years
                $last_year--;
                $arr_snow_months= $arr_snow_nh; // snow months from oct to april
        }
}
function ws_snow_load_txt($file) {
        global $SITE;
        global $this_year,  $last_year;
        global $snow_first, $snow_last;
        global $arr_snow_months;

        $my     = basename(__FILE__).' -> '.__FUNCTION__;
        ws_message ('<!-- '.$my.' ('.__LINE__.'): this function loaded -->');
        
        ws_snow_globals ();    
        $arr_loaded     = array();
        $data_in_text   = array ('year' => 1, 'month' => 2, 'day' => 3, 'unit' => 4, 'height' => 5, 'extra' => 6, 'melt' => 7);

        if (!is_file($file) ) {
                ws_message ('<!-- '.$my.' ('.__LINE__.'): file '.$file.' not found -->');
                return false;
        }
        ws_message ('<!-- '.$my.' ('.__LINE__.'): file '.$file.' loaded -->');
        $arr    = file($file);
        $cnt    = count($arr);
        if ($cnt < 1) {
                ws_message ('<!-- '.$my.' ('.__LINE__.'): file '.$file.' empty -->');
                return false;
        }
        ws_message ('<!-- '.$my.' ('.__LINE__.'): file '.$file.' loaded '.$cnt.' lines -->');
 #       echo '<pre>'.print_r($arr,true);
        $error  = false;
        for ($n = 0; $n < $cnt; $n++) {
                $error  = false;
                $string = trim($arr[$n]).'#';   // remove spaces new lines
                $first  = substr($string,0,1);  // check first character
                if ($first == '#' || $first <> '|' ) {
                        ws_message ('<!-- '.$my.' ('.__LINE__.'): file '.$file.': skipped comment / invalid line starting with '.$first.' -->');
                        continue;
                }
                $ymd    = '';
                $content= explode ('|', $string.'|||||',10);    // load values into array.
# now check the fields in the line for errors
                $pointer= $data_in_text['year'];
                $string = trim($content[$pointer]);
                if ($string == $this_year || $string == $last_year ) {
                        $line_year      = $string;
                        $ymd            = $line_year;
                }
                else {  $error          = true;
                        ws_message ('<!-- '.$my.' ('.__LINE__.'): file '.$file.': year field '.$string.' invalid -->');
                }
                $pointer= $data_in_text['month'];
                $string = trim($content[$pointer]);
                $value  = 1.0 * $string;
                if ($value > 0 && $value < 13) {                // valid months
                        if ($arr_snow_months[$value] <> 0) {    // is month in snow season
# ??                                $line_month     = $arr_snow_months[$value];
                                $ymd            = $ymd.substr ('0'.$string,-2);
                        }
                        else {  $error  = true;
                                ws_message ('<!-- '.$my.' ('.__LINE__.'): file '.$file.': month field '.$string.' invalid -->');                      
                        }
                }
                else {  $error  = true;
                        ws_message ('<!-- '.$my.' ('.__LINE__.'): file '.$file.': month field '.$string.' invalid -->');
                }
        # calculate the last day for this month
                if ($value == 12) {
                        $last_day_month = 31;
                }
                else {  $string         = (string) ($ymd + 1).'00T120000';
                        $last_day_month = date ('d',strtotime ($string) );
                }
                $pointer= $data_in_text['day'];
                $string = trim($content[$pointer]);
                $value  = 1.0 * $string;
                if ($value > 0 && $value <= $last_day_month) {
                        $line_day       = $string;
                        $ymd            = $ymd.substr ('0'.$string,-2);
                }
                else {  $error  = true;
                        ws_message ('<!-- '.$my.' ('.__LINE__.'): file '.$file.': day field '.$string.' invalid '.$last_day_month.' -->');
                }
                $pointer= $data_in_text['height'];
                $string = trim($content[$pointer]);
                if ($string == '') {$string = '0';}
                $value  = 1.0 * $string;
                if ((string) $value <> $string || $value < 0 || $value > 999) {
                        $error  = true;
                        ws_message ('<!-- '.$my.' ('.__LINE__.'): file '.$file.': height field '.$string.' / '.$content[$pointer].' invalid -->');
                }
                else {  $line_height    = $string;       
                }
                $pointer= $data_in_text['extra'];
                $string = trim($content[$pointer]);
                if ($string == '') {$string = '0';}
                $value  = 1.0 * $string;
                if ((string) $value <> $string || $value < 0 || $value > 999) {
                        $error  = true;
                        ws_message ('<!-- '.$my.' ('.__LINE__.'): file '.$file.': extra field '.$string.' / '.$content[$pointer].' invalid -->');
                }
                else {  $line_new_snow  = $string;       
                }
/*                $pointer= $data_in_text['melt'];
                $string = trim($content[$pointer]);
                $value  = 1.0 * $string;
                if ((string) $value <> $string || $value < 0 || $value > 999) {
                        $error  = true;
                        ws_message ('<!-- module '.$my.' ('.__LINE__.'): file '.$file.': melt field '.$string.' invalid -->');
                }
                else {  $line_last_melt = $string;       
                }
*/
                $line_last_melt = 0;
                if (!$error) {
                        $arr_loaded[$ymd]       = array ('ymd' => $ymd, 'height' => $line_height, 'new_snow' => $line_new_snow,  'last_melt' => $line_last_melt );
                }                                                      
   #             echo '<pre>$value = '.$value.PHP_EOL.print_r($content,true); exit;
        }
# sort array on date
        ksort($arr_loaded);
# echo '<pre>'.print_r($arr_loaded,true); exit;
        $last_height    = 0;
        foreach ($arr_loaded as $key => $arr) {
                $melt           = $last_height + $arr['new_snow'] - $arr['height'];
                if ($melt < 0) {
                        $arr_loaded[$key]['new_snow'] = $arr_loaded[$key]['new_snow'] - $melt;
                        $melt   = 0;
                }
                $arr_loaded [$key]['last_melt'] = $melt;
                $last_height    = $arr['height'];
        }
        krsort($arr_loaded);
        return $arr_loaded;
}  // eo function ws_load_snow
?>
</div>
<!-- end of ws_snow.php -->
<?php
# ----------------------  version history
# 0.00 2016-01-20	first version